# coding: utf-8

"""
    Maestro API

    Maestro authors and executes experiences that allow non-coders the ability to define Simple Business Process without having to write code and to deploy them seamlessly without having to have development expertise  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..client.configuration import Configuration
from ..client.api_client import ApiClient


class WorkflowTriggerApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def trigger_workflow(self, account_id, workflow_definition_id, body, **kwargs):
        """
        Creates a new workflow instance after authenticating with DS Account Server
        Creates a new workflow instance after authenticating with DS Account Server
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.trigger_workflow(account_id, workflow_definition_id, body, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str account_id: Account ID (required)
        :param str workflow_definition_id: Workflow Definition ID (required)
        :param str mtid: Managed Token Id registered with DS Account Server
        :param str mtsec: Managed Token Secret registered with DS Account Server
        :param TriggerPayload body: JSON payload that will be passed to the triggered workflow (required)
        :return: TriggerWorkflowViaPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.trigger_workflow_with_http_info(account_id, workflow_definition_id, body, **kwargs)
        else:
            (data) = self.trigger_workflow_with_http_info(account_id, workflow_definition_id, body, **kwargs)
            return data

    def trigger_workflow_with_http_info(self, account_id, workflow_definition_id, body, **kwargs):
        """
        Creates a new workflow instance after authenticating with DS Account Server
        Creates a new workflow instance after authenticating with DS Account Server
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.trigger_workflow_with_http_info(account_id, workflow_definition_id, body, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str account_id: Account ID (required)
        :param str workflow_definition_id: Workflow Definition ID (required)
        :param str mtid: Managed Token Id registered with DS Account Server
        :param str mtsec: Managed Token Secret registered with DS Account Server
        :param TriggerPayload body: JSON payload that will be passed to the triggered workflow (required)
        :return: TriggerWorkflowViaPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['account_id', 'workflow_definition_id', 'mtid', 'mtsec', 'body']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method trigger_workflow" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `trigger_workflow`")
        # verify the required parameter 'workflow_definition_id' is set
        if ('workflow_definition_id' not in params) or (params['workflow_definition_id'] is None):
            raise ValueError("Missing the required parameter `workflow_definition_id` when calling `trigger_workflow`")
        # verify the required parameter 'body' is set
        if ('body' not in params) or (params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `trigger_workflow`")


        collection_formats = {}

        resource_path = '/v1/accounts/{accountId}/workflow_definitions/{workflowDefinitionId}/trigger'.replace('{format}', 'json')
        path_params = {}
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'workflow_definition_id' in params:
            path_params['workflowDefinitionId'] = params['workflow_definition_id']

        query_params = {}
        if 'mtid' in params:
            query_params['mtid'] = params['mtid']
        if 'mtsec' in params:
            query_params['mtsec'] = params['mtsec']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='TriggerWorkflowViaPostResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
