# coding: utf-8

"""
    Maestro API

    Maestro authors and executes experiences that allow non-coders the ability to define Simple Business Process without having to write code and to deploy them seamlessly without having to have development expertise  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_maestro.client.configuration import Configuration


class StartedByInstance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'started_by_id': 'str',
        'started_by_name': 'str',
        'started_by_type': 'str'
    }

    attribute_map = {
        'started_by_id': 'startedById',
        'started_by_name': 'startedByName',
        'started_by_type': 'startedByType'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """StartedByInstance - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._started_by_id = None
        self._started_by_name = None
        self._started_by_type = None
        self.discriminator = None

        setattr(self, "_{}".format('started_by_id'), kwargs.get('started_by_id', None))
        setattr(self, "_{}".format('started_by_name'), kwargs.get('started_by_name', None))
        setattr(self, "_{}".format('started_by_type'), kwargs.get('started_by_type', None))

    @property
    def started_by_id(self):
        """Gets the started_by_id of this StartedByInstance.  # noqa: E501


        :return: The started_by_id of this StartedByInstance.  # noqa: E501
        :rtype: str
        """
        return self._started_by_id

    @started_by_id.setter
    def started_by_id(self, started_by_id):
        """Sets the started_by_id of this StartedByInstance.


        :param started_by_id: The started_by_id of this StartedByInstance.  # noqa: E501
        :type: str
        """

        self._started_by_id = started_by_id

    @property
    def started_by_name(self):
        """Gets the started_by_name of this StartedByInstance.  # noqa: E501

        The user name of the person who starts a workflow Instance  # noqa: E501

        :return: The started_by_name of this StartedByInstance.  # noqa: E501
        :rtype: str
        """
        return self._started_by_name

    @started_by_name.setter
    def started_by_name(self, started_by_name):
        """Sets the started_by_name of this StartedByInstance.

        The user name of the person who starts a workflow Instance  # noqa: E501

        :param started_by_name: The started_by_name of this StartedByInstance.  # noqa: E501
        :type: str
        """

        self._started_by_name = started_by_name

    @property
    def started_by_type(self):
        """Gets the started_by_type of this StartedByInstance.  # noqa: E501


        :return: The started_by_type of this StartedByInstance.  # noqa: E501
        :rtype: str
        """
        return self._started_by_type

    @started_by_type.setter
    def started_by_type(self, started_by_type):
        """Sets the started_by_type of this StartedByInstance.


        :param started_by_type: The started_by_type of this StartedByInstance.  # noqa: E501
        :type: str
        """
        allowed_values = ["Anonymous", "Preparer", "Participant", "OnBehalfOf"]  # noqa: E501
        if (self._configuration.client_side_validation and
                started_by_type not in allowed_values):
            raise ValueError(
                "Invalid value for `started_by_type` ({0}), must be one of {1}"  # noqa: E501
                .format(started_by_type, allowed_values)
            )

        self._started_by_type = started_by_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StartedByInstance, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StartedByInstance):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StartedByInstance):
            return True

        return self.to_dict() != other.to_dict()
